
#pragma once

#include <vector>
#include <algorithm>

template <class Thread>
class CThreadMonitor
{
protected:
	typedef std::vector<Thread*> ThreadList;
	typedef typename ThreadList::iterator ThreadListIterator;
	ThreadList threads;
public:

	CThreadMonitor()
	{
	}

	virtual ~CThreadMonitor()
	{
	}

	void AddThread(Thread *thread)
	{
		threads.push_back( thread );
	}

	bool IsAllActive()
	{
		if ( threads.empty() ) {
			return true;
		}

		for (ThreadListIterator itr = threads.begin(); itr != threads.end(); ++itr) {
			if ( !(*itr)->IsActive() ) {
				return false;
			}
		}
		return true;
	}

};
