// multithread_interdependence.cpp : R\[ AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include <algorithm>
#include <vector>

#include "Thread.h"
#include "ThreadMonitor.h"
#include "Instance.h"

#include "MainThread.h"
#include "AddCalculator.h"
#include "AntiReverseThread.h"


template <class Thread, class Monitor>
class CStartupThreadScheduler : public Monitor
{
public:
	CStartupThreadScheduler()
	{
	}

	~CStartupThreadScheduler()
	{
		if ( threads.empty() ) {
			return;
		}
		struct Del {
			void operator ()(Thread *thread)
			{
				delete thread;
			}
		};
		std::for_each( threads.begin(), threads.end(), Del() );
	}

	int Monitor()
	{
		while (true) {
			if ( !Monitor::IsAllActive() ) {
				puts( "CStartupThreadScheduler::Monitor() - thread down " );
				CMainThread *main = dynamic_cast<CMainThread*>(threads[0]);
				if ( main != NULL ) {
					main->loop = false;
				}
				break;
			}
			puts( "CStartupThreadScheduler::Monitor()" );
			Sleep( 4000 );
		}
		return 0;
	}
};

int main(int argc, char* argv[])
{
	CStartupThreadScheduler<CThread, CThreadMonitor<CThread> > scheduler;

	CMainThread *mainThread = new CMainThread();
	CAddCalculator *add = new CAddCalculator();
	CAntiReverseThread *anti = new CAntiReverseThread();

	add->AddThread( mainThread );
	add->AddThread( anti );
	anti->AddThread( mainThread );
	anti->AddThread( add );

	scheduler.AddThread( mainThread );
	scheduler.AddThread( add );
	scheduler.AddThread( anti );

	return scheduler.Monitor();
}

